// This snippet creates a new dialog box
// with buttons on the bottom.

//Title:       RFTP ConnectDialog
//Version:     1.0
//Copyright:   1999
//Author:      Mary Grzywa
//Company:     Illinois State University Graduate Project
//Description: Resumable File Transfer Protocol

package  rftp;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class ConnectDialog extends JDialog {
  JPanel panel1 = new JPanel();
  JPanel panel2 = new JPanel();
  JButton button1 = new JButton();
  JButton button2 = new JButton();
  Border border1;
  JPanel jPanel1 = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridLayout gridLayout1 = new GridLayout();
  JLabel RemoteHostLabel = new JLabel();
  JTextField remoteHostTextField = new JTextField();
  JLabel ConnectStatusLabel = new JLabel();
  FrameFM myParent = null;

  public ConnectDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    pack();
  }

  public ConnectDialog(Frame frame, String title) {
    this(frame, title, false);
  }

  public ConnectDialog(Frame frame) {
    this(frame, "", false);
  }

  private void jbInit() throws Exception {
    border1 = BorderFactory.createRaisedBevelBorder();
    jPanel1.setLayout(gridLayout1);
    panel2.setBorder(border1);
    panel2.setLayout(null);
    button1.setText("Connect");
    button1.addActionListener(new ConnectDialog_button1_actionAdapter(this));
    button2.setText("Cancel");
    gridLayout1.setHgap(4);
    button2.addActionListener(new ConnectDialog_button2_actionAdapter(this));
    this.addWindowListener(new ConnectDialog_this_windowAdapter(this));
    panel1.setLayout(gridBagLayout1);
    RemoteHostLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    RemoteHostLabel.setText("Remote Host: ");
    RemoteHostLabel.setBounds(new Rectangle(16, 39, 88, 17));
    remoteHostTextField.setBounds(new Rectangle(112, 38, 248, 21));
    remoteHostTextField.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        remoteHostTextField_actionPerformed(e);
      }
    });
    ConnectStatusLabel.setBounds(new Rectangle(22, 97, 344, 23));
    panel1.setMinimumSize(new Dimension(420, 180));
    panel1.setPreferredSize(new Dimension(420, 180));
    panel1.add(panel2, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(RemoteHostLabel, null);
    panel2.add(remoteHostTextField, null);
    panel2.add(ConnectStatusLabel, null);
    panel1.add(jPanel1, new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(4, 8, 4, 8), 0, 0));
    jPanel1.add(button1, null);
    jPanel1.add(button2, null);
    getContentPane().add(panel1);
}

  // OK
  void button1_actionPerformed(ActionEvent e) {
  // Connect to the Server
  if (myParent == null) setParent(FrameFM.getConnectDialogsFileMover(this));
  getmyParent().appendToHistory("Connecting");
  // Set the server name to the IP or DNS address given
	String SetServrNameResult = getmyParent().getTheClient().setServerName(remoteHostTextField.getText());
  // Display the server name in the upper right of FileMover
	ConnectStatusLabel.setText(SetServrNameResult);
	String y = getmyParent().handleServerResponse(SetServrNameResult);
  // Contact the server & put the response in the session history
	String ServerResult =  getmyParent().getTheClient().contactServer();
	String ServerResultClean = getmyParent().handleServerResponse(ServerResult);
	//System.out.println("ServerResult Reply: " + ServerResult);
	//System.out.println("connConnecttoServer Reply: " + connConnectToServerResult);
	ConnectStatusLabel.setText("");
	if (ServerResult.startsWith("2"))    // replies starting with 2 indicate success
	{  //System.out.println("connConnecttoServer Reply starts with 2: " + ServerResult);
		  ConnectStatusLabel.setText("Connected. Ready for Login");
		  getmyParent().setStatus("Connected");
      getmyParent().setServerNameLabel(remoteHostTextField.getText());
      // connection time is kept to ensure that sufficient set up time is given to RftpClient and RftpCurrentDirectory
		  java.util.Date loginTime = new java.util.Date();
	    long connTime = loginTime.getTime();
	    getmyParent().setConnectTimeInSeconds(connTime);
	    this.dispose();
	}
 }
  public FrameFM getmyParent() {
	return myParent;
}
 public void setParent(FrameFM newValue) {
	this.myParent = newValue;
}
  // Cancel
  void button2_actionPerformed(ActionEvent e) {
    dispose();
  }

  void this_windowClosing(WindowEvent e) {
    dispose();
  }

   void remoteHostTextField_actionPerformed(ActionEvent e) {
       button1_actionPerformed(e);
  }


}

class ConnectDialog_button1_actionAdapter implements ActionListener {
  ConnectDialog adaptee;

  ConnectDialog_button1_actionAdapter(ConnectDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.button1_actionPerformed(e);
  }
}

class ConnectDialog_button2_actionAdapter implements ActionListener {
  ConnectDialog adaptee;

  ConnectDialog_button2_actionAdapter(ConnectDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.button2_actionPerformed(e);
  }
}

class ConnectDialog_this_windowAdapter extends WindowAdapter {
  ConnectDialog adaptee;

  ConnectDialog_this_windowAdapter(ConnectDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void windowClosing(WindowEvent e) {
    adaptee.this_windowClosing(e);
  }
}
