// This snippet creates a new dialog box
// with buttons on the bottom.

//Title:       RFTP LoginDialog
///Version:    1.0
//Copyright:   1999
//Author:      Mary Grzywa
//Company:     Illinois State University Graduate Project
//Description: Resumable File Transfer Protocol
package  rftp;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class LoginDialog extends JDialog {
  JPanel panel1 = new JPanel();
  JPanel panel2 = new JPanel();
  JButton Loginbutton = new JButton();
  JButton button2 = new JButton();
  Border border1;
  JPanel jPanel1 = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridLayout gridLayout1 = new GridLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextField LoginTextField = new JTextField();
  JPasswordField PasswordField = new JPasswordField();
  FrameFM myParent;
  JLabel LoginStatus = new JLabel();

  public LoginDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    pack();
  }

  public LoginDialog(Frame frame, String title) {
    this(frame, title, false);
  }

  public LoginDialog(Frame frame) {
    this(frame, "", false);
  }

  private void jbInit() throws Exception {
    border1 = BorderFactory.createRaisedBevelBorder();
    jPanel1.setLayout(gridLayout1);
    panel2.setBorder(border1);
    panel2.setLayout(null);
    Loginbutton.setText("Login");
    Loginbutton.addActionListener(new LoginDialog_Loginbutton_actionAdapter(this));
    button2.setText("Cancel");
    gridLayout1.setHgap(4);
    button2.addActionListener(new LoginDialog_button2_actionAdapter(this));
    this.addWindowListener(new LoginDialog_this_windowAdapter(this));
    panel1.setLayout(gridBagLayout1);
    jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel1.setText("Login: ");
    jLabel1.setBounds(new Rectangle(39, 56, 52, 17));
    jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel2.setText("Password: ");
    jLabel2.setBounds(new Rectangle(17, 89, 75, 17));
    LoginTextField.setBounds(new Rectangle(98, 53, 248, 21));
    LoginTextField.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        LoginTextField_actionPerformed(e);
      }
    });
    PasswordField.setBounds(new Rectangle(98, 89, 248, 21));
    panel1.setMinimumSize(new Dimension(420, 200));
    panel1.setPreferredSize(new Dimension(420, 200));
    LoginStatus.setBounds(new Rectangle(32, 134, 321, 17));
    panel1.add(panel2, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    panel2.add(jLabel1, null);
    panel2.add(jLabel2, null);
    panel2.add(LoginTextField, null);
    panel2.add(PasswordField, null);
    panel2.add(LoginStatus, null);
    panel1.add(jPanel1, new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(4, 8, 4, 8), 0, 0));
    jPanel1.add(Loginbutton, null);
    jPanel1.add(button2, null);
    getContentPane().add(panel1);
    myParent = null;
}

  // OK
  void Loginbutton_actionPerformed(ActionEvent e) {
  StringBuffer loginCmdSB = new StringBuffer("USER ");
	StringBuffer passCmdSB = new StringBuffer("PASS ");
	loginCmdSB.append(LoginTextField.getText());
  if (myParent == null) setParent(FrameFM.getLoginDialogParent(this));
     	getmyParent().appendToHistory("Connecting");
	// a login performed while the rftpClient is still performing
	// the connection setup can cause a hang.  Setting 9 seconds wait
	//  between the connect & login.  Also waiting 2.5 seconds between sending commands
	 
	java.util.Date loginTime = new java.util.Date();
	  long loginTimeInSeconds = loginTime.getTime();
	  long connTime = myParent.connectTimeInSeconds;
	  //System.out.println("c: " + (new Long(connTime)).toString() + " L: " + ( new Long(loginTimeInSeconds)).toString());
	  long timepassed = loginTimeInSeconds - connTime;
	  if ( timepassed < 5000)
	     {	try   {java.lang.Thread.sleep(5000 - timepassed);	}
		      catch (java.lang.InterruptedException eee) {}
	     }
  LoginStatus.setText("Logging In...Please wait");  
	String performedRequest = myParent.getTheClient().performRequest(loginCmdSB);
	passCmdSB.append(PasswordField.getPassword());
	try	{java.lang.Thread.sleep(2500);	} catch (java.lang.InterruptedException eeeeee) {}
	String loginReply = myParent.getTheClient().performRequest(passCmdSB);
	String yyy = myParent.handleServerResponse(loginReply);
	if (loginReply.indexOf("230") >= 0)
	{
	   try {java.lang.Thread.sleep(2500);	} catch (java.lang.InterruptedException eeffe) {}
	   String pwdReply = myParent.getTheClient().performRequest(new StringBuffer("PWD"));
	   String cleaned = myParent.handleServerResponse(pwdReply);
	   String strippedPwdReply = myParent.stripAwayNewlines(cleaned);
	   //System.out.println("LoginPerformButton....sendLoginCmd: stripped: " + strippedPwdReply + "END");
	   myParent.RemoteDirTextField.setText(strippedPwdReply);
	   String listReply = myParent.getTheClient().performRequest(new StringBuffer("LIST"));
	   myParent.setStatus("Ready");
	   myParent.displayRemoteDirectory(listReply);
	   this.dispose();
    }
  else LoginStatus.setText("Login Failed.  Please try again.");
 }
  // Cancel
  void button2_actionPerformed(ActionEvent e) {
    dispose();
  }

  void this_windowClosing(WindowEvent e) {
    dispose();
  }
public FrameFM getmyParent() {
	return myParent;
}
public void setParent(FrameFM newValue) {
	this.myParent = newValue;
}

  void LoginTextField_actionPerformed(ActionEvent e) {

  }
}

class LoginDialog_Loginbutton_actionAdapter implements ActionListener {
  LoginDialog adaptee;

  LoginDialog_Loginbutton_actionAdapter(LoginDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.Loginbutton_actionPerformed(e);
  }
}

class LoginDialog_button2_actionAdapter implements ActionListener {
  LoginDialog adaptee;

  LoginDialog_button2_actionAdapter(LoginDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.button2_actionPerformed(e);
  }
}

class LoginDialog_this_windowAdapter extends WindowAdapter {
  LoginDialog adaptee;

  LoginDialog_this_windowAdapter(LoginDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void windowClosing(WindowEvent e) {
    adaptee.this_windowClosing(e);
  }

}
 
