// This snippet creates a new dialog box
// with buttons on the bottom.

//Title:       RFTP NewDirDialog
///Version:    1.0
//Copyright:   1999
//Author:      Mary Grzywa
//Company:     Illinois State University Graduate Project
//Description: Resumable File Transfer Protocol

package  rftp;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class NewDirDialog extends JDialog {
  JPanel panel1 = new JPanel();
  JPanel panel2 = new JPanel();
  JButton button1 = new JButton();
  JButton button2 = new JButton();
  Border border1;
  JPanel jPanel1 = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridLayout gridLayout1 = new GridLayout();
  JLabel jLabel1 = new JLabel();
  JTextField jTextField1 = new JTextField();
  FrameFM myParent = null;

  public NewDirDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    pack();
  }

  public NewDirDialog(Frame frame, String title) {
    this(frame, title, false);
  }

  public NewDirDialog(Frame frame) {
    this(frame, "", false);
  }

  private void jbInit() throws Exception {
    border1 = BorderFactory.createRaisedBevelBorder();
    jPanel1.setLayout(gridLayout1);
    panel2.setBorder(border1);
    panel2.addComponentListener(new java.awt.event.ComponentAdapter() {

      public void componentShown(ComponentEvent e) {
        panel2_componentShown(e);
      }
    });
    panel2.setLayout(null);
    button1.setText("Create");
    button1.addActionListener(new NewDirDialog_button1_actionAdapter(this));
    button2.setText("Cancel");
    gridLayout1.setHgap(4);
    button2.addActionListener(new NewDirDialog_button2_actionAdapter(this));
    this.addWindowListener(new NewDirDialog_this_windowAdapter(this));
    panel1.setLayout(gridBagLayout1);
    jLabel1.setText("Remote Directory: ");
    jLabel1.setBounds(new Rectangle(5, 69, 101, 17));
    jTextField1.setBounds(new Rectangle(111, 67, 282, 21));
    jTextField1.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jTextField1_actionPerformed(e);
      }
    });
    panel1.add(panel2, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 1, 0), 0, 0));
    panel2.add(jLabel1, null);
    panel2.add(jTextField1, null);
    panel1.add(jPanel1, new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(4, 8, 4, 8), 0, 0));
    jPanel1.add(button1, null);
    jPanel1.add(button2, null);
    panel1.setMinimumSize(new Dimension(420, 180));
    panel1.setPreferredSize(new Dimension(420, 180));
    getContentPane().add(panel1);
    //jTextField1.setText(getmyParent().getRemoteDirectoryName());
}

  // OK
  void button1_actionPerformed(ActionEvent e) {
    String cmd = "MKD " + jTextField1.getText();
    getmyParent().appendToHistory("Creating directory: "  + jTextField1.getText());
    String reply = getmyParent().handleServerResponse(getmyParent().getTheClient().performRequest(new StringBuffer(cmd)));
    if (reply.startsWith("2"))     // 2 indicates success
    {
         getmyParent().appendToHistory("Directory Created : "  + jTextField1.getText());
         String listReply = getmyParent().getTheClient().performRequest(new StringBuffer("LIST"));
	       getmyParent().displayRemoteDirectory(listReply);
    }
    dispose();
  }

  // Cancel
  void button2_actionPerformed(ActionEvent e) {
    dispose();
  }

  void this_windowClosing(WindowEvent e) {
    dispose();
  }
  public FrameFM getmyParent() {
     if (myParent == null)
      myParent = FrameFM.getMakeDirParent(this) ;
     return myParent;
 }

  void jTextField1_actionPerformed(ActionEvent e) {
        button1_actionPerformed(e);
  }

  void panel2_componentShown(ComponentEvent e) {
     jTextField1.setText(getmyParent().getRemoteDirectoryName());
  }
}

class NewDirDialog_button1_actionAdapter implements ActionListener {
  NewDirDialog adaptee;

  NewDirDialog_button1_actionAdapter(NewDirDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.button1_actionPerformed(e);
  }
}

class NewDirDialog_button2_actionAdapter implements ActionListener {
  NewDirDialog adaptee;

  NewDirDialog_button2_actionAdapter(NewDirDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.button2_actionPerformed(e);
  }
}

class NewDirDialog_this_windowAdapter extends WindowAdapter {
  NewDirDialog adaptee;

  NewDirDialog_this_windowAdapter(NewDirDialog adaptee) {
    this.adaptee = adaptee;
  }

  public void windowClosing(WindowEvent e) {
    adaptee.this_windowClosing(e);
  }
}
