package rftp;

import java.util.*;
import java.util.Vector.*;                  
import java.util.Date.*;
import java.lang.*;
import java.lang.String.*;
import java.io.*;
import java.net.*;

public class RftpClient {
	
private static final int SERVER_CMD_PORT = 2301;
private static final int client_data_port = 2405;
private static final boolean AUTOFLUSH = true;
private static final int MAX_CLIENTS = 50;
private String serverName;
private String IPaddress;
private Socket cmdSocket = null;
private BufferedReader cmdReceive = null;
private PrintWriter cmdSend = null;
private boolean DATA_CONNECTED = false;
private boolean DEBUG = false;
private boolean TRANSFER_IN_PROGRESS = false;
private boolean LOGGED_IN = false;
private rftp.RftpDataClient dataLink;
private int TRANSFERSIZE = 0;
private boolean DIRECTORY_CHANGED = false;
private rftp.RftpCurrentDirectory currentDirectory;
StringBuffer workingDirectory = new StringBuffer(30);
//private static java.util.Vector ClientVec = new java.util.Vector(20,20);
public RftpTransferClient newTransfer = null;
	
	public boolean dataLinkInitialized = false;
/**
 * Constructor
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
public RftpClient() {
	super();
	initialize();
  //addToVector();
}
//*******************************************************************************************
//*******************************************************************************************
public RftpClient(String[] args) 
{
	if (args.length >= 1)
	{
	   serverName = args[0];
	}

	dataLink = new rftp.RftpDataClient();
	dataLink.setDEBUG(DEBUG);
	dataLinkInitialized = true;

}   //end public RftpClient() constructor

//*******************************************************************************************
//*******************************************************************************************
protected String ABOR_STAT_HELP_ok(String cmd)
{
if (cmd.startsWith("ABOR")) {return SimpleCmd(cmd);}
else if (cmd.startsWith("STAT")) {return MultiLineReplycmd(currentDirectory.adjustRelativePathname(cmd,2));}
else if (cmd.startsWith("HELP")) {return HELPcmd(cmd);}
else return "A file is being transferred.  \nUntil it is finished, only the ABOR, STAT, and HELP commands may be used.";
}
//*******************************************************************************************
//*******************************************************************************************
protected String CDcmd(String cmd)

/* The change directory command is not supported by java and therefore can't be done
by the server.  The current directory information is kept by the RftpCurrentDirectory class. 
Commands to the server are altered as needed to reflect the current directory  */
{
  String reply = null;
  if (!DIRECTORY_CHANGED )
  {
	DIRECTORY_CHANGED = true;
	DataIncmd("PWD");
	currentDirectory = new rftp.RftpCurrentDirectory(workingDirectory.toString());
  } 
  StringBuffer pwdCmd = new StringBuffer("PWD ");
  String m = currentDirectory.changeDirectory(cmd);
  if (m.equals(null))
  {
     return "500 ***File Access denied***";
  }
  pwdCmd.append(m);
  // System.out.println("pwdCmd: " + pwdCmd.toString());
  return DataIncmd(pwdCmd.toString());
}
//*******************************************************************************************
//*******************************************************************************************

protected boolean cmdConnectOK()
{
return (cmdSend != null && cmdReceive != null && cmdSocket != null);
}  //end protected boolean cmdConnectOK()
//*******************************************************************************************
//*******************************************************************************************

protected String cmdIn()
{
   String cmdInput = null;
   try
	{  
	   cmdInput = cmdReceive.readLine();
	   if (DEBUG) System.out.println(cmdInput);
	} 
   catch (IOException excpt) 
	{
	System.out.println("I/O Exception While contacting server: " + excpt);
	System.exit(1);
	}
   if (cmdInput.startsWith("421",0)) 
	{
	QUITcmd("QUIT");
	  System.exit(1);
	}
   return cmdInput;
}
//*******************************************************************************************
//*******************************************************************************************
public String contactServer()
{
	try
	{   if (DEBUG) System.out.println("DEBUG: Contact Server: getting cmd socket");
		InetAddress serverIP = InetAddress.getByName(serverName);
		cmdSocket = new Socket (serverIP, SERVER_CMD_PORT);
		cmdReceive = new BufferedReader(new InputStreamReader(cmdSocket.getInputStream()));
		cmdSend = new PrintWriter(cmdSocket.getOutputStream(),AUTOFLUSH);
	}
	catch (UnknownHostException excpt){
		if (DEBUG) System.out.println("Unknown host Exception : " + excpt);
		return "Unknown host Exception : " + excpt;}
	catch (IOException excpt) {
		if (DEBUG) System.out.println("I/O Exception While contacting server: " + excpt);
		return "I/O Exception While contacting server: " + excpt;}
	return cmdIn();
}   // end public String contactServerCmd()
//**********************************************************************************
//***********************************************************************************
protected String DataIncmd(String cmd) 
{  
   String finalReply = null;
   String dataReply = null;
   if (!dataLinkInitialized)
   {
	   dataLink = new RftpDataClient();
	   dataLink.setDEBUG(DEBUG);
	   dataLinkInitialized = true;
   }
   if (DEBUG) System.out.println("DEBUG: Sending to server: " + cmd);
   cmdSend.println(cmd);
   String Sreply = cmdIn();
   if (DEBUG) System.out.println("DEBUG:Sreply: " + Sreply);
   if (Sreply.startsWith("150"))
   {
   if (DEBUG) System.out.println ("DEBUG before dataconnect" + DATA_CONNECTED );
	if (!DATA_CONNECTED) DATA_CONNECTED = dataLink.acceptDataConnection("CHARACTER DATA");
	if (DEBUG)System.out.println("DEBUG after dataconnect");
	if (Sreply.startsWith("1",0))               //server sending another message
	 finalReply = Sreply + cmdIn() ;
	  else finalReply = Sreply;
	if (DEBUG)System.out.println("DEBUG before DataStringIn");
	dataReply = dataLink.dataStringIn();
	if (cmd.startsWith("PWD"))
	{
	   workingDirectory.setLength(0);
	   workingDirectory.append(dataReply);         
	}
	if (DATA_CONNECTED) 
	{
  	  dataLink.closeDataConnection();
	  DATA_CONNECTED = false;
	}
   }
   return finalReply + "\n" + dataReply + "\n" ;
}
//*******************************************************************************************
//*******************************************************************************************
protected String debugMode(String cmd)
{
  if (DEBUG) DEBUG = false; else DEBUG = true;
  dataLink.setDEBUG(DEBUG);
  cmdSend.println(cmd + " " + DEBUG);
  return cmdIn();
}
/**
 * This method was created in VisualAge.
 * @return boolean
 */
public boolean getDataLinkInitialized() {
	return dataLinkInitialized;
}
//*******************************************************************************************
//*******************************************************************************************
public boolean TransferInProgress()
{
return TRANSFER_IN_PROGRESS;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
//*******************************************************************************************
//*******************************************************************************************
protected String HELPcmd(String cmd) { return " "; }
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	// user code begin {1}
	// user code end
	// user code begin {2}
	// user code end
}
//*******************************************************************************************
//*******************************************************************************************
protected boolean inLoginProcess(String cmd)
{
if (cmd.startsWith("USER")) return true;
 else if (cmd.startsWith("PASS")) return true;
  else if (cmd.startsWith("ACCT")) return true;
   else if (cmd.startsWith("QUIT")) return true;
	else return false;
}
//*******************************************************************************************
//*******************************************************************************************
protected String LISTcmd(String cmd) 
{
   StringTokenizer st = new StringTokenizer(cmd);
   int n = st.countTokens();

   if (n > 1 ) return DataIncmd(currentDirectory.adjustRelativePathname(cmd,2));
   else return DataIncmd("LIST " + currentDirectory.getWorkingDir()); 
}
//*******************************************************************************************
//*******************************************************************************************
public boolean loggedInToServer(){return LOGGED_IN;}
//*******************************************************************************************
//*******************************************************************************************
protected String LOGINcmd(String cmd)
{
	cmdSend.println(cmd);
	String reply = cmdIn();
	if (reply.startsWith("2",0) && (cmd.startsWith("PASS"))) LOGGED_IN = true;
	return reply;
}
//*******************************************************************************************
//*******************************************************************************************
public static void main(String[] args) 
{
	RftpClient client = new RftpClient(args);
}   //end public static void main(String[] args) 
//*******************************************************************************************
//*******************************************************************************************

protected String MultiLineReplycmd(String cmd) 
{ 
   StringBuffer multiLine = new StringBuffer("");
   cmdSend.println(cmd);
   multiLine.append(cmdIn());
   try
   {
	 while (cmdReceive.ready()) multiLine.append(cmdIn()).append("\n");  
   } catch (IOException eee) {}
   return multiLine.toString();
}
//*******************************************************************************************
//*******************************************************************************************
protected String NLSTcmd(String cmd) {return " ";  }
//*******************************************************************************************
//*******************************************************************************************

public String performRequest(StringBuffer request)
{
	  String command = request.toString();
	if (DEBUG) System.out.println("DEBUG:***" + command + "***");
	if ((!LOGGED_IN)&& (!inLoginProcess(command))) {return "Must login before issuing commands.";}
	  if ((LOGGED_IN) && (!DIRECTORY_CHANGED ))  CDcmd("CD ");
	if (TRANSFER_IN_PROGRESS) return ABOR_STAT_HELP_ok(command);
	 else if (command.startsWith("USER")) {return LOGINcmd(command);}
	   else if (command.startsWith("PASS")) {return LOGINcmd(command);}
	     else if (command.startsWith("ACCT")) {return LOGINcmd(command);}
			else if (command.startsWith("CWD")) {return CDcmd(command);}
			 else if (command.startsWith("CDUP")) {return CDcmd(command);}
		      else if (command.startsWith("CD")) {return CDcmd(command);}
			   else if (command.startsWith("QUIT")) {return QUITcmd(command);}
				else if (command.startsWith("REIN")) {return REINcmd(command);}
	 		     else if (command.startsWith("RETR")) {return RETRcmd(command);}
		      else if (command.startsWith("STOR")) {return STORcmd(command);}
		        else if (command.startsWith("REST")) {return RESTcmd(command);}
		         else if (command.startsWith("RNFR")) {return RNFRcmd(command);}
		          else if (command.startsWith("RNTO")) {return RNTOcmd(command);}
		           else if (command.startsWith("ABOR")) {return SimpleCmd(command);}
		            else if (command.startsWith("DELE")) {return SimpleCmd(currentDirectory.adjustRelativePathname(command,2));}
		             else if (command.startsWith("RMD")) {return RMDcmd(currentDirectory.adjustRelativePathname(command,2));}
		              else if (command.startsWith("MKD")) {return SimpleCmd(currentDirectory.adjustRelativePathname(command,2));}
		               else if (command.startsWith("PWD")) {return PWDcmd(command);}
		                else if (command.startsWith("LIST")) {return LISTcmd(command);} 
		                 else if (command.startsWith("NLST")) {return NLSTcmd(command);}
		                  else if (command.startsWith("SITE")) {return SITEcmd(command);}
		                   else if (command.startsWith("SYST")) {return SYSTcmd(command);}
		                    else if (command.startsWith("STAT")) {return MultiLineReplycmd(currentDirectory.adjustRelativePathname(command,2));}
		                     else if (command.startsWith("HELP")) {return SimpleCmd(command);}
		                       else if (command.startsWith("DEBUG")) {return debugMode(command);}
						else return "Illegal command";
	
}  //end protected void fillRequest
//*******************************************************************************************
//*******************************************************************************************
protected String PWDcmd(String cmd)
{
  if (!DIRECTORY_CHANGED ) return DataIncmd("PWD");
   else return DataIncmd("PWD " + currentDirectory.getWorkingDir());
}
//*******************************************************************************************
//*******************************************************************************************
protected String QUITcmd(String cmd)
{
	String serverBye = null;
	try
	{
		if (cmdConnectOK())      //send quit and get bye if connection is up
		{
			 cmdSend.println("QUIT");
			 serverBye = cmdIn();
		}
		if (cmdSend != null) cmdSend.close();
		if (cmdReceive != null) cmdReceive.close();
		if (cmdSocket != null)  cmdSocket.close();
		dataLink.closeDataConnection();

	} catch (IOException excpt) {System.out.println("Failed I/O to server " + excpt);}
	return serverBye;
}   // end public String QUITcmd()
//*******************************************************************************************
//*******************************************************************************************
protected String REINcmd(String cmd) {return " ";  }
//*******************************************************************************************
//*******************************************************************************************
protected String RESTcmd(String cmd) {return " ";  }
//*******************************************************************************************
//*******************************************************************************************
protected String RETRcmd(String cmd) 
{  //Transfer a file from the server to the client machine
  
  //***************
  long t1, t2; //time to calculate the time difference in milli secs.
  //***************

  boolean RESUME = false;
  File newFile = null;
  FileOutputStream newLocalFOS = null;
  int resumeAt = 0;
  StringTokenizer st = new StringTokenizer(cmd);
  int n = st.countTokens();
  String skipover = st.nextToken();  // the RETR command
  if (n < 3)  // no filename given with RETR command
  {
	return "Usage:  RETR  remotefilename localfilename [+]";
  }
  else  // RETR command entered with at least 1 parameter
  {
	String remoteFileEntered = st.nextToken();
	String remoteFile = currentDirectory.adjustRelativePathname(remoteFileEntered);
	String localFile = null;
	if (n >= 3) 
	{  //if the next parameter is a plus sign, then resume transfer is in effect
	   String nt = st.nextToken(); 
	   if (nt.equals("+")) 
	 {
	   localFile = remoteFileEntered;
	   RESUME = true; 
	 }
	   else localFile = nt;
	}
	if (n >= 4)  //if the next parameter is a plus sign, then resume transfer is in effect.
	{
	if  (st.nextToken().equals("+")) RESUME = true; 
	}
	cmdSend.println("STAT " + remoteFile);
	String rfStat = cmdIn();
	if (rfStat.startsWith("213",0))    //a file that can be transfered
	{
	   int sizePtr = rfStat.indexOf("Size: ") ;
	   if (sizePtr >= 0)
	   {
		 String rfSizeStr = rfStat.substring(sizePtr + 6, rfStat.length() - 3).trim();
		 TRANSFERSIZE = new Integer(rfSizeStr).intValue();
	   }
	   try
	   {
		 newFile = new File(localFile);
		 if (!RESUME) 
	   {
		newLocalFOS = new  FileOutputStream(localFile);  //this creates file if doesn't exist already
		resumeAt = 0;   //Start at the beginning of the file
	   }
	   else  //RESUME transfer from end of existing file
	   {
		if (!newFile.exists())  //in case someone tries to resume on a file that doesn't exist - create the file
		     newLocalFOS = new FileOutputStream(localFile); 
		resumeAt = (int) newFile.length();
	   }
	   } catch (IOException ecpt){} 

	   cmdSend.println("RETR " + remoteFile + " " + localFile + " " + Integer.toString(resumeAt));   //send the command to server
	   String reply = cmdIn(); 
	   if (!(reply.startsWith("4",0) || reply.startsWith("5",0)) )  // not error messages
	   {
		if (!DATA_CONNECTED) DATA_CONNECTED = dataLink.acceptDataConnection("FILE TRANSFER");

	  TRANSFER_IN_PROGRESS = true;
 	  // Start a thread to do the data transfer
	  newTransfer = new RftpTransferClient(dataLink,this,newFile,resumeAt, "IN");
   	//	newTransfer = new RftpTransferClient(dataLink,newFile,resumeAt, "IN");
	  Thread newTransferThread = new Thread(newTransfer);
	  newTransferThread.start();

 		//****************************
		Date time1 = new Date();
		t1 = time1.getTime();
		System.out.println("***************\nStarting RETR now at time: " + t1 + "\n****************");
		//****************************

    dataLink.setTotalBytesToTransfer((long)(TRANSFERSIZE - resumeAt));
	   }
	   return reply;
	 }
   return rfStat;   //return status of requested object - it wasn't a transferable file
   } 
}
//*******************************************************************************************
//*******************************************************************************************
protected String RMDcmd(String cmd) { return " "; }
//*******************************************************************************************
//*******************************************************************************************
protected String RNFRcmd(String cmd) { return " "; }
//*******************************************************************************************
//*******************************************************************************************
protected String RNTOcmd(String cmd) { return " "; }
/**
 * This method was created in VisualAge.
 * @param newValue boolean
 */
public void setDataLinkInitialized(boolean newValue) {
	this.dataLinkInitialized = newValue;
}
//*******************************************************************************************
//*******************************************************************************************

public String setServerName(String s) { serverName = s; return serverName;}
//*******************************************************************************************
//*******************************************************************************************
public void setTransferComplete()
{
  TRANSFER_IN_PROGRESS = false;
  TRANSFERSIZE = 0;
  DATA_CONNECTED = false;
  if (DEBUG)System.out.println("DEBUG: File Transfer Complete");

	//****************************
	Date time1 = new Date();
	long t1 = time1.getTime();
	System.out.println("***************\nTransfer complete at time: " + t1 + "\n****************");
	//****************************

  cmdIn();
}
//*******************************************************************************************
//*******************************************************************************************
public int getTransferSize()
{
 return TRANSFERSIZE;
}
//*******************************************************************************************
//*******************************************************************************************

protected String SimpleCmd(String cmd)
{
	//****************************
	Date time1 = new Date();
	long t1 = time1.getTime();
	System.out.println("***************\nPerhaps Aborting at time: " + t1 + "\n****************");
	//****************************

   cmdSend.println(cmd);
   return cmdIn();
}
//*******************************************************************************************
//*******************************************************************************************
protected String SITEcmd(String cmd) {return " ";  }
//*******************************************************************************************
//*******************************************************************************************
protected String STORcmd(String cmd) 
{ 
  File sendFile = null;
  boolean RESUME = false;
  int remoteFileSize = 0;
  String localFile = null;
  StringTokenizer st = new StringTokenizer(cmd);
  int n = st.countTokens();
  String skipover = st.nextToken();  // the STOR command
  if (n < 3)  // no filename given with STOR command
  {
	return "Usage:  STOR localfilename remotefilename [+]";
  }
  else  // STOR command entered with at least 1 parameter
  {
	localFile = st.nextToken();
	String remoteFile = null;
	if (n >= 3) 
	{
	String thirdToken = st.nextToken(); 
	if (thirdToken.equals("+")) 
	{
	   remoteFile = currentDirectory.adjustRelativePathname(localFile);
	   RESUME = true;
	}
	else remoteFile = currentDirectory.adjustRelativePathname(thirdToken);
	if (n >= 4)
	{
	  if (st.nextToken().equals("+")) RESUME = true;
	}
	 }
	 sendFile = new File(localFile);
	 if (sendFile.isFile())
	 {  
	 if (RESUME)
	 {
	   // list the remotefile to see if it exists & get the size if it does.

	   cmdSend.println("STAT " + remoteFile);
	   String rfStat = cmdIn();
     // System.out.println(rfStat);
	   // if the remotefile exists remotely, the sizePtr will be > 0 & show where the size is
		 if (!rfStat.startsWith("213",0)) return rfStat;   //it is a file
		 else
		 {
	      int sizePtr = rfStat.indexOf("Size: ");
	      if (sizePtr > 0 )
	      {
		       String rfSizeStr = rfStat.substring(sizePtr + 6, rfStat.length() - 3).trim();
	 	       remoteFileSize = new Integer(rfSizeStr).intValue();
	      }
	   }
   }
	 cmdSend.println(cmd);   //send the command to server
	 String reply = cmdIn();
	 if (!(reply.startsWith("4",0) || reply.startsWith("5",0)) )  // not error messages
	 {
		  if (!DATA_CONNECTED) DATA_CONNECTED = dataLink.acceptDataConnection("FILE TRANSFER");
      // changed from transfersize = sendfile.length() - remotefilesize
	    TRANSFERSIZE = (int) sendFile.length();
	    TRANSFER_IN_PROGRESS = true;
 	    // Start a thread to do the data transfer
		  RftpTransferClient newTransfer = new RftpTransferClient(dataLink,this,sendFile,remoteFileSize, "OUT");
      // System.out.println("RftpClient is " + this.toString());
      //newTransfer = new RftpTransferClient(dataLink,sendFile,remoteFileSize, "OUT");
      //System.out.println("RftpTransferClient is " + newTransfer.toString());
	    Thread newTransferThread = new Thread(newTransfer);
      newTransferThread.start();

		//****************************
		Date time1 = new Date();
		long t1 = time1.getTime();
		System.out.println("***************\nStarting STOR at time: " + t1 + "\n****************");
		//****************************
	 }
	 return reply;   //the error message from server's response to request to transfer
  }
  } return "File " + localFile + " to transfer not found";
}
//*******************************************************************************************
//*******************************************************************************************
protected String SYSTcmd(String cmd) {return " "; }
public rftp.RftpDataClient getDataLink() {return dataLink;}
}   //end public class RftpClient

class RftpTransferClient implements Runnable
{
private rftp.RftpDataClient dataLink;
private RftpClient parent;
private File dataFile;
private int startPosition;
private String direction;
private byte dataInput[] = new byte[64000];

/* This thread keeps track of its parent to inform it when the data
transfer is completed.  */

public RftpTransferClient(RftpDataClient dl, RftpClient p, File f, int pos, String dir)
{
   dataLink = dl;
   parent = p;
   dataFile = f;
   startPosition = pos;
   direction = dir;
}
public void run()
{
   if (direction.equals("IN")) dataLink.transferFileIn(dataFile,startPosition);
	  else dataLink.transferFileOut(dataFile,startPosition);
   dataLink.closeDataConnection();
   parent.setTransferComplete();
}
}  //end class RftpTransferClient
