
//Title:        RFTP
//Version:      1.0
//Copyright:    Copyright (c) 1999
//Author:       Mary Grzywa
//Company:      Illinois State University Graduate Project
//Description:  Resumable File Transfer Protocol

package rftp;

import java.awt.*;
import javax.swing.*;

public class RftpHelp extends JFrame {
JPanel jPanel1 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList jList1 = new JList();
  DefaultListModel HelpList = new DefaultListModel();

  public RftpHelp() {
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    jPanel1.setLayout(null);
    jScrollPane1.setBounds(new Rectangle(7, 7, 620, 620));
    jList1.setModel(HelpList);
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jScrollPane1, null);
    jScrollPane1.getViewport().add(jList1, null);
    this.setSize(new Dimension(660, 660));
    this.setTitle("RFTP Help");
    HelpList.addElement("GETTING STARTED");
    HelpList.addElement("   ");
    HelpList.addElement("Resumable file transfer protocol (rftp) allows the user to transfer files " );
    HelpList.addElement("between computers using the Internet.  The person on the user side of the");
    HelpList.addElement("connection can be given permission by the server side to browse the folders");
    HelpList.addElement("and files of the server computer.  Rftp also has the ability to resume the ");
    HelpList.addElement("download of a file after the download has been interrupted by loss of a ");
    HelpList.addElement("connection, or interrupted by the user.  ");
    HelpList.addElement(" ");
    HelpList.addElement("Downloading large files is easy with rftp's convenient interface and  " );
    HelpList.addElement(" resumable file transfers.   Users with lower (28k, 56 k) connection speeds ");
    HelpList.addElement(" whose downloads take proportionally more time, or home users sharing one " );
    HelpList.addElement("line for  both voice and data have a higher risk that a connection could  " );
    HelpList.addElement("accidentally be  lost during a download.  Using rftp to transfer files means that");
    HelpList.addElement("if a transfer is  interrupted, the time already invested in downloading isn't " );
    HelpList.addElement("wasted. ");
    HelpList.addElement(" ");
    HelpList.addElement("CONNECTING TO THE SERVER");
    HelpList.addElement("In order to connect to the other machine, the user must know the server's  " );
    HelpList.addElement("Internet Protocol address.  This address is displayed on the server machine" );
    HelpList.addElement("when Rftp Server is started.  The IP address will look something like: ");
    HelpList.addElement("138.87.100.38");
    HelpList.addElement("When you first start Rftp File Mover, a message in the status area tells you " );
    HelpList.addElement("that you are not connected.  In order to connect to the server, click on the  ");
    HelpList.addElement("connect icon, enter the IP address of the server in the dialog box, and then ");
    HelpList.addElement("click on the connect button.  A message in the Rftp File Mover status area will");
    HelpList.addElement("tell you that you are connected.  The IP address will appear in the server address " );
    HelpList.addElement("area.  ");
    HelpList.addElement(" ");
    HelpList.addElement("LOGGING IN TO THE SERVER");
    HelpList.addElement("After you are connected, you must log into the server. To login, first click on ");
    HelpList.addElement("the login icon. Then enter your user name in the login text box. Enter your");
    HelpList.addElement("password in the password text box, and click on the login button. ");
    HelpList.addElement("The message Ready will appear in the Rftp File Mover status area when  " );
    HelpList.addElement("you are connected.   The remote file system area will display a list of the files");
    HelpList.addElement("and folders from the server's computer.    Now you are ready to browse" );
    HelpList.addElement("around the  server folders and transfer files. ");
    HelpList.addElement(" ");
    HelpList.addElement("When you are done, disconnect from the server using the disconnect icon. " );
     HelpList.addElement(" This will end your session with the Rftp Server.  Exit from File Mover by   ");
    HelpList.addElement(" choosing File | Exit. ");

    HelpList.addElement("   ");
    HelpList.addElement("LOOKING AT THE SERVER");
     HelpList.addElement("The text area lists the files and folders found in the current folder.  The " );
    HelpList.addElement(" current folder is named in the textbox labeled   look in.  The folders are"); 
    HelpList.addElement("labeled with <dir> to distinguish them from regular files.  Remember as you " );
    HelpList.addElement("browse around that the server may not allow you access to all its folders and ");
    HelpList.addElement(" files.  If you attempt to go to a folder where you are not allowed, you will ");
    HelpList.addElement("automatically be putback into your default directory.  The actions you can use " );
    HelpList.addElement("to browse around the file system are: ");
    HelpList.addElement( " "  );
    HelpList.addElement(" "   );
    HelpList.addElement("    Change current folder to one in the current directory");
    HelpList.addElement("          Single Click on a folder to make it the current folder.  Be patient!  Since" );
    HelpList.addElement( "         you are communicating across the Internet, it will take several seconds" );
    HelpList.addElement("          before anything happens.  The folder's name will be displayed in the " );
    HelpList.addElement("          textbox labeled look in and its contents displayed in the text area. ");
    HelpList.addElement(" "                      );
    HelpList.addElement("    Go up one level "  );
    HelpList.addElement("          Single Click on the go up one level icon to move up one folder in the ");
    HelpList.addElement("          file system. " );
    HelpList.addElement(" "   );
    HelpList.addElement("   Change current folder"     );
    HelpList.addElement("          You can type in the entire pathname of the folder you want to become "  );
    HelpList.addElement("          the current folder in the textbox labeled look in.  Highlight the folder " );
    HelpList.addElement("          name that is there, delete it, type in the pathname desired, and hit enter.");
   HelpList.addElement(" "   );
    HelpList.addElement("OTHER USEFUL ACTIONS "  );
    HelpList.addElement(" "    );
    HelpList.addElement("  Select a file"    );
    HelpList.addElement("         Single Click on a filename to select it.  It will be highlighted in blue, and its "   );
    HelpList.addElement("         size in bytes and the date it was last modified will be displayed. " );
    HelpList.addElement(" "        );
    HelpList.addElement("  Create a new folder");
    HelpList.addElement("          Single click on the new folder icon to create a new folder on the server "  );
    HelpList.addElement("          computer.  A new folder dialog box appears.  Type in just the name of the "   );
    HelpList.addElement("          new  folder, and it will be created in the current folder.   Or you may type in"  );
    HelpList.addElement("          a complete pathname.  However, if you do this, the upper level folders " );
    HelpList.addElement("          must already  exist.  Only the one folder named at the end of the pathname");
    HelpList.addElement("          should be new. "  );
    HelpList.addElement(" ");
    HelpList.addElement("    Refresh the listing" );
    HelpList.addElement("          Single click the refresh icon to request a new list of the folders and files in " );
    HelpList.addElement("          the current folder.  The refresh icon is useful when you create a new folder "   );
    HelpList.addElement("          and when a file transfer creates a new file. " );
    HelpList.addElement(" "                         );
    HelpList.addElement("    Show the session history"  );
    HelpList.addElement("          Single click the show history icon to display a behind the scenes look at" );
    HelpList.addElement("          your connection session.  The history session window shows a complete"  );
    HelpList.addElement("          listing of the actions you have performed during the connection.  It"   );
    HelpList.addElement("          displays the folder changes you have made, the files you have selected"  );
    HelpList.addElement("          with their sizes and date modified, the folders (directories) you have"   );
    HelpList.addElement("          created, and the file transfers.  It contains all the messages that the "     );
    HelpList.addElement("          server has sent to your machine.  If it looks like a file transfer didn't work, " );
    HelpList.addElement("          or you can't change to a folder, check the session history to see if there is " );
    HelpList.addElement("          a message explaining what happened."  );
    HelpList.addElement(" ");
    HelpList.addElement("TRANSFERRING FILES");
    HelpList.addElement("Resumable file transfer protocol can transfer files from the server to the local"   );
    HelpList.addElement("host, or from the local host to the server.  It can also resume transfers that were" );
    HelpList.addElement("started and then interrupted.  This starts the transfer at the point where it was"   );
    HelpList.addElement("interrupted to avoid the need to resend data that was previously sent.  When a ");
    HelpList.addElement("transfer is resumed, it is the user's responsibility to ensure that the files chosen " );
    HelpList.addElement("are the files on which a transfer was interrupted and that neither of those files "  );
    HelpList.addElement("have been altered since the original transfer.  If the user erroneously resumes a"     );
    HelpList.addElement("transfer to a file, that file can be corrupted. "  );
    HelpList.addElement(" "           );
    HelpList.addElement("PERFORMING A FILE TRANSER");
    HelpList.addElement(" "                       );
    HelpList.addElement(" 1. (Recommended) Select local file. " );
    HelpList.addElement(" 2. (Recommended) Select remote file. ");
    HelpList.addElement(" 3. Left Click on the icon for the desired type of file transfer  " );
    HelpList.addElement("    Retrieve, Resume retrieve, Store , or Resume store"  );
    HelpList.addElement(" 4. Verify that the transfer that will be performed is the type of transfer desired by "  );
    HelpList.addElement("    carefully checking the transfer message displayed in the transfer file dialog box.");
    HelpList.addElement(" 5. (Optional)  Filenames may be typed directly into the textboxes.  If the file being ");
    HelpList.addElement("    transferred to does not already exist, it will be automatically created.  However, " );
    HelpList.addElement("    folders are not automatically created; they must already exist.  The entire " );
    HelpList.addElement("    filename, including the extension, (.txt in the example) needs to be typed.  The ");
    HelpList.addElement("    entire pathname may be used, or a relative pathname. ");
    HelpList.addElement(" 6. Click on the Transfer button in the transfer file dialog box. ");
    HelpList.addElement(" "               );
    HelpList.addElement("As the transfer is taking place, the progress of the transfer is displayed in the " );
    HelpList.addElement("transfer status area.   When the transfer is complete, the status is changed " );
    HelpList.addElement(" back to ready. ");
HelpList.addElement(" "    );
    HelpList.addElement("ABORTING A FILE TRANSFER"  );
    HelpList.addElement("You can interrupt and stop a file transfer at any time during the transfer by " );
    HelpList.addElement("clicking on the abort transfer icon.  Aborting a transfer takes a few seconds, so " );
    HelpList.addElement("if you abort a small transfer, or one that is near completion, the transfer may " );
    HelpList.addElement("complete before the transfer is halted.  Comparing file sizes will show if the " );
    HelpList.addElement("transfer aborted or completed. The transfer can be resumed later and will start " );
    HelpList.addElement("up where it stopped. ");
    HelpList.addElement(" ");
    HelpList.addElement("PROBLEM SOLVING TIPS");
    HelpList.addElement(" ");
    HelpList.addElement("In the connect dialog box, I typed in the IP address and nothing happened: ");
    HelpList.addElement("     * Make sure the IP address is correct and that you only type in the ");
    HelpList.addElement("       numbers separated by periods. ");
    HelpList.addElement("     * Check to see if Rftp Server on the IP address you typed in is running");
    HelpList.addElement("     * Was Rftp Server started on the IP address you typed in, but the ");
    HelpList.addElement("        permission file name hasn't been entered yet? ");
    HelpList.addElement(" ");
    HelpList.addElement("In the login dialog box, after I entered my password, nothing happened. ");
    HelpList.addElement("      * Did you click on the login button? ");
    HelpList.addElement("      * It can take up to 45 seconds to establish the connection and initialize ");
    HelpList.addElement("         the remote directory listing. ");
    HelpList.addElement(" ");
    HelpList.addElement("In the login dialog box, I got a Login failed.  Please try again.  message. ");
    HelpList.addElement("       * Check that the user name and password were correctly typed in. ");
    HelpList.addElement("       * Check that the permission file exists and was typed in correctly for the ");
    HelpList.addElement("           Rftp Server. ");
    HelpList.addElement(" ");
    HelpList.addElement("I change folders, but keep getting put back into the original folder");
    HelpList.addElement("        * Look in the Session History.  If the folder changes are failing, you don't ");
    HelpList.addElement( "           have access permission for the folder you are trying to change to. ");

  }
}

