//Title:       RFTP SecurityManager
///Version:    1.0
//Copyright:   1999
//Author:      Mary Grzywa
//Company:     Illinois State University Graduate Project
//Description: Resumable File Transfer Protocol
package rftp;
import java.io.*;
import java.lang.*;
import java.util.*;

// Checks the permissions file and verifies that the login / password is valid
// Supplies the directory name at the top of the tree the user is allowed access to
//
// permissions file contains one line per user.  Each line contains the user login, password,
// and top allowed directory; separated by tabs or spaces.     If the directory is an asterisk,
// all locations are allowed.

public class RftpSecurityManager {

  String[] login = new String[100];
  String[] pass  = new String[100];
  String[] dir   = new String[100];
  boolean permissionsExist = true;
  BufferedReader fi = null;
  File rftpPermission = null;
  int NumberOfLogins = 0;

  public RftpSecurityManager(File permission) {
  try {
  
    rftpPermission = permission;
    fi = new BufferedReader(new FileReader(rftpPermission.getAbsolutePath()));
    readPermissions();
  } catch (FileNotFoundException fnfe)
     {System.out.println("Permissions file not found"); permissionsExist = false;}
  }

  private boolean invokedStandalone = false;

  private void readPermissions() {
     int i = 0;
     try {
      if (permissionsExist) {
        StringBuffer inLine = new StringBuffer("");
        boolean notdone = true;
            while ( notdone ) {
               inLine.append(fi.readLine()) ;
               StringTokenizer st = new StringTokenizer(inLine.toString());
               int n = st.countTokens();
               if (n == 3)
               {
                 login[i] = st.nextToken();
                 pass[i] = st.nextToken();
                 dir[i] = st.nextToken();
                 i++;
                 inLine.setLength(0);
                }
                else notdone = false;
              }   //end of while
       }  //end of if
      }   //end of try
      catch (NullPointerException npe) {}
      catch (IOException ioe) {}
     // catch (java.lang.InterruptedException eee) {}
     NumberOfLogins = i ;
     // System.out.println("number of logins: " + Integer.toString(NumberOfLogins));
     try { fi.close(); } catch (IOException ioeioe ) {}
 }
 
  public String getPermissions(String l, String p)
  {
    for (int i = 0; i <  NumberOfLogins; i++) {
      if ((l.equals(login[i])) && (p.equals(pass[i])))
        return dir[i];
     }
  return "Invalid Login or Password";
  }
}