package rftp;

import java.util.*;
import java.util.Vector.*;
import java.util.Date.*;
import java.lang.*;
import java.lang.String.*;
import java.io.*;
import java.net.*;


public class RftpServer 
{
private static final int SERVER_CMD_PORT = 2301;
private static final int MAX_CLIENTS = 50;
private static final boolean AUTOFLUSH = true;
private InetAddress server;
private String IPaddress;
private ServerSocket listenCmdSocket = null;
private static Vector handlerVec = new Vector(25,20);
private File logFile;
private FileOutputStream logOutStream = null;
private PrintWriter logSendPW = null;
private BufferedReader consoleIn = new BufferedReader(new InputStreamReader(System.in));
private File permissionsFile;
private static String separator;
private static boolean onWindows = true;
private boolean keepRunning = true;

//*******************************************************************************************
//*******************************************************************************************
public RftpServer() 
{  
    // create the log file
	Calendar cal = Calendar.getInstance();
  String mm = Integer.toString(cal.get(Calendar.MONTH) + 1);
  String mma;
  if (mm.length() == 2) mma = mm;  else mma = "0" + mm;
  String dd =  Integer.toString(cal.get(Calendar.DAY_OF_MONTH));
	String dda;
	if (dd.length() == 2) dda = dd; else dda = "0" + dd;
	String hd = Integer.toString(cal.get(Calendar.HOUR_OF_DAY)) ;
	String hda;
	if (hd.length() == 2) hda = hd; else hda = "0" + hd;
	String min = Integer.toString(cal.get(Calendar.MINUTE));
	String mina;
	if (min.length() == 2) mina = min; else mina = "0" + min; 
  String currentTime = Integer.toString(cal.get(Calendar.YEAR)) + mma + dda + hda + mina;
				
  try
 	{
    File logDirectory = new File("log");
    if (!logDirectory.exists()) logDirectory.mkdir();

	  logOutStream = new FileOutputStream("log" + separator + currentTime + ".txt");
	  logFile = new File("log" + separator + currentTime + ".txt");
    logSendPW = new PrintWriter (new FileOutputStream(logFile), AUTOFLUSH);
 	}   catch(IOException excpt) {}

  // Get the permission file name
   
   try
    {
        System.in.read();
        System.out.print("Enter the access permissions file name: ");
        byte[] userInput = new byte[101];
        int amtread = System.in.read(userInput);
        String xx = new String(userInput);
        if (onWindows) permissionsFile = new File(xx.substring(0,amtread - 2));
          else  permissionsFile = new File(xx.substring(0,amtread - 1));
         if (!permissionsFile.exists())
           {
                System.out.println("Permissions file not found.");
                System.out.println("Please exit the server, check that permissions file exists & try again.");
           }
           else {
                 System.out.println("Permissions file is " + permissionsFile.getAbsolutePath() );
                 System.out.println("Ready to serve clients.");
                 }
    } catch (IOException exc) { System.out.println("Read Error on console input: " + exc);}
      catch (NullPointerException npe) { System.out.println("Null Pointer on console input: " + npe);}
    // create listen socket
    try
    { 
        listenCmdSocket = new ServerSocket(SERVER_CMD_PORT,MAX_CLIENTS);
    }   catch(IOException excpt) 
        {
	      System.out.println("Server IOException while listening at command socket" + excpt);
        }

}   //end public RftpServer() constructor

//*******************************************************************************************
//*******************************************************************************************
public static void main(String[] args) 
{   File f = new File(".");
    String xx = f.getAbsolutePath();
    String here = xx.substring(0,(xx.length()-2));
    System.out.println(here);
    int mslast = here.lastIndexOf("\\");
   	int unixlast = here.lastIndexOf("/");
  	if (mslast > unixlast)
        separator = "\\";
     else
     {
        separator = "/";
        onWindows = false;
     }
    System.out.println("Connect to the Internet, then press any key to continue.");
  try {  System.in.read(); } catch (IOException ee) {}
  try
    {
        InetAddress myIP = InetAddress.getLocalHost();
        System.out.println("My IP: " + myIP.toString());
    } catch (UnknownHostException uhe) 
      {
	      System.out.println("Unknown host when getting local host: " + uhe);
	      System.exit(1);
	    }

    RftpServer server = new RftpServer();
    server.serveRftpClients();

}   //end public static void main(String[] args) 

//*******************************************************************************************
//*******************************************************************************************
public void serveRftpClients()
{
    Socket clientCmdSocket = null;

    // accept incoming client connections
    try
    {
     while (keepRunning)
     {
		   clientCmdSocket = listenCmdSocket.accept();
 		   // create a handler for the client and start the thread
		   RftpHandler newClient = new RftpHandler(clientCmdSocket,logSendPW,handlerVec.size() + 1,permissionsFile);
		   Thread newClientThread = new Thread(newClient);
 	   	 handlerVec.addElement(newClientThread);
	     newClientThread.start();
     }
    } catch (IOException excpt) {System.out.println("I/O Exception: " + excpt);}
}   // end public void serveRftpClients()

//*******************************************************************************************
//*******************************************************************************************
protected void stop(){if (keepRunning) {keepRunning = false;}  //end protected void stop()

}   //end class RftpClient 

//*******************************************************************************************
//*******************************************************************************************
//*******************************************************************************************
//*******************************************************************************************

class RftpHandler implements Runnable
{
//  Manages a client connection
private boolean AUTOFLUSH = true;     //JDK1.1.6 co
private Socket cmdSocket = null;
private PrintWriter cmdSend = null;
private BufferedReader cmdReceive = null;
private PrintWriter logSend = null;
private String username = null;
private String password = null;
private File currentDirectory = new File(".");
private InetAddress clientIP = null;
private RftpDataServer dataLink;
private File permissionsFile = null;
RftpTransferServer newTransfer = null;
private boolean DEBUG = false;
private boolean TRANSFER_IN_PROGRESS = false;

private int clientId;
private String allowedDirectory = null;
//*******************************************************************************************
//*******************************************************************************************
public RftpHandler(Socket newCmdSocket,PrintWriter log, int clientNumber, File permissions)
{
    cmdSocket = newCmdSocket;
    clientId = clientNumber;
    logSend = log;
    permissionsFile = permissions;
}   // end constructor public RftpHandler(Socket newSocket)

//*******************************************************************************************
//*******************************************************************************************
public void run()
{
   // run implements the communication
    try
    {
      clientIP = cmdSocket.getInetAddress(); 
      cmdReceive = new BufferedReader(new InputStreamReader(cmdSocket.getInputStream()));
      cmdSend = new PrintWriter(cmdSocket.getOutputStream(),AUTOFLUSH);

      cmdOut("220 ***Service Ready***");
    
      dataLink = new RftpDataServer(clientIP,clientId);
      if (login())
       {
 		      command_reply();
       }
      logout();
    }
    catch (IOException excpt) 
    {
	System.out.println("Server Handler I/O Exception: " + excpt);
    } 
}  //end public void run

//*******************************************************************************************
//*******************************************************************************************
protected boolean login()
{
    String nextLine;
    StringTokenizer tokens;
    StringBuffer command = new StringBuffer(80);
    int i = 0;
    boolean gotCorrectCmd = false;
    /*try
    { */
        // read in response from client
	  // allow 3 attempts to send the user command before failing
    for (int z = 0; z < 3 ; z++)
    {
	  for (i = 0; i < 3 && !gotCorrectCmd; i++)
	  {
	     command.setLength(0);
	     command.append(cmdIn());
       StringTokenizer st = new StringTokenizer(command.toString());
 	     int n = st.countTokens();
 	     if (st.nextToken().startsWith("USER",0))
	 	   {    // need to verify that the username was submitted
 		     if (n  < 2)
		      { cmdOut("400 ***USER command requires name of user.***" ) ;   }
		     else
 		     {
		      gotCorrectCmd = true;
		      username = st.nextToken();
	   	    cmdOut("331 ***User name " + username + ".  Need Password.***");
		     }
	 	   }  //endif
	     else    //it didn't start with user
		   {
		  	if (command.toString().startsWith("HELP",0))
			  {
			    i--;     //HELP command is allowed before USER command
			    HELPcmd(command.toString());
		   	}
			  else cmdOut("500 ***Bad sequence of commands. USER command required.***");
		   }   //endelse
	  }   // end for loop i
	  if (gotCorrectCmd)   // Now get the password  
	  {
	     gotCorrectCmd = false;
           for (i = 0; i < 3 && !gotCorrectCmd; i++)
	        {
	        command.setLength(0);
	        command.append(cmdIn());
          StringTokenizer st = new StringTokenizer(command.toString());
 	        int n = st.countTokens();
 	        if (st.nextToken().startsWith("PASS",0))
	 	      {   // need to verify that the password was submitted
 		        if (n < 2)
		        {  cmdOut("400 ***PASS command requires password.***" ) ; }
		        else
 		        {
		          gotCorrectCmd = true;
		          password = st.nextToken();
		          if (validuser(username,password))
		          {
	   	         cmdOut("230 ***Login complete.***");
		  	      //NEED TO IMPLEMENT AN OPTIONAL ACCT REQUIREMENT PER RFC 959
			        // IF ACCT INFO WILL BE REQUIRED, REPLY HERE WITH 332
            	 return true;
		          }
		       }
	 	      }
	        else cmdOut("503 ***Bad sequence of commands. PASS command required.***");
          }    //end for i loop 3 chances to give the pass cmd
	  }    //endif
    cmdOut("530 ***Login Failed.  Please try again.***"); 
    }  // end of z for loop
	  
	  return false;  //didn't get a valid USER command
}  // end login   

//*******************************************************************************************
//*******************************************************************************************
protected String cmdIn()
{
   String cmdInput = null;

   Calendar cal = Calendar.getInstance();
   Date date = cal.getTime();

   try
    {
       cmdInput = cmdReceive.readLine();
	     logSend.println(date.toString() + " CLIENT: " + clientId + " CMD_IN: " + cmdInput);
	     if (DEBUG) System.out.println(" CMD_IN: " + cmdInput);
    } 
   catch (IOException excpt) {}  //rftphandler has shut down & control will be returned to server
   if (DEBUG) System.out.println("DEBUG Client " + clientId + ": **" + cmdInput + "**");
   return cmdInput;
}
//*******************************************************************************************
//*******************************************************************************************
protected void cmdOut(String cmdLine)
{
   Calendar cal = Calendar.getInstance();
   Date date = cal.getTime();

   cmdSend.println(cmdLine);
   logSend.println(date.toString() + " CLIENT: " + clientId + " CMD_OUT: " + cmdLine);
   if (DEBUG) System.out.println(date.toString() + " CLIENT: " + clientId + " CMD_OUT: " + cmdLine);

}
//*******************************************************************************************
//*******************************************************************************************

protected boolean validuser(String username,String password)
{
  rftp.RftpSecurityManager security = new rftp.RftpSecurityManager(permissionsFile);
  allowedDirectory = security.getPermissions(username,password);
  if (allowedDirectory.equals("Invalid Login or Password")) return false;
   else return true;
}
//*******************************************************************************************
//*******************************************************************************************
public boolean FilePermissionOK(String requestedFile)  {
       File rFile = new File(requestedFile);
       // User is never allowed access to the permissions file
       if (permissionsFile.getAbsolutePath().equals(rFile.getAbsolutePath())) return false;
       if (allowedDirectory.equals("*"))  return true;   // anything is allowed
       if (rFile.getAbsolutePath().startsWith(allowedDirectory))  return true;
       return false;
    }
//*******************************************************************************************
//*******************************************************************************************

protected void command_reply()
{
        String nextLine = null;
        while ((nextLine = cmdIn()) != null)
	  {try
        {
		StringTokenizer st = new StringTokenizer(nextLine);
          	String command = st.nextToken();
		if (command.equals("ACCT")) {ACCTcmd(nextLine);}
       else if (command.equals("QUIT")) {QUITcmd(nextLine);}
        else if (command.equals("REIN")) {REINcmd(nextLine);}
     		 else if (command.equals("RETR")) {RETRcmd(nextLine);}
		      else if (command.equals("STOR")) {STORcmd(nextLine);}
		        else if (command.equals("RNFR")) {RNFRcmd(nextLine);}
		         else if (command.equals("RNTO")) {RNTOcmd(nextLine);}
		          else if (command.equals("ABOR")) {ABORcmd(nextLine);}
		           else if (command.equals("DELE")) {DELEcmd(nextLine);}
		            else if (command.equals("RMD")) {RMDcmd(nextLine);}
		             else if (command.equals("MKD")) {MKDcmd(nextLine);}
		              else if (command.equals("PWD")) {PWDcmd(nextLine);}
		               else if (command.equals("LIST")) {LISTcmd(nextLine);}
		                else if (command.equals("NLST")) {NLSTcmd(nextLine);}
		                 else if (command.equals("SITE")) {SITEcmd(nextLine);}
		                  else if (command.equals("SYST")) {SYSTcmd(nextLine);}
		                   else if (command.equals("STAT")) {STATcmd(nextLine);}
		                    else if (command.equals("HELP")) {HELPcmd(nextLine);}
		                     else if (command.equals("DEBUG")) {DEBUGcmd(nextLine);}
					    else cmdOut("500 ***Syntax error, command unrecognized.***");

	}
	catch (NoSuchElementException nsee) {}
	}
}  //end protected void command_reply()

//*******************************************************************************************
//*******************************************************************************************
protected void QUITcmd(String cmdLine)
{
    cmdOut("200 ***Logging out***");
    logout();
}
//*******************************************************************************************
//*******************************************************************************************
protected void RETRcmd(String cmdLine)
{  // RETREIVE COMMAND
  int offsetAmt = 0;
  boolean continueOn = true;
  StringTokenizer st = new StringTokenizer(cmdLine);
  int n = st.countTokens();
  if (n < 2)  cmdOut("501 ***Syntax error in parameters or arguments***");
  else
  {
    String skipover = st.nextToken();   //first token is the RETR
    String retrieveMe = st.nextToken();   
    File retrFile = new File(retrieveMe);
    if (!FilePermissionOK(retrieveMe))  {
       cmdOut("500 ***File Access denied***");
       return;
    }
    if (n >= 3)
    { 
	String sendingTo = st.nextToken();  //the file on client side
    } 
    if (DEBUG) System.out.println("DEBUG Client " + clientId + ": RETR parameters: " + Integer.toString(n));
    if (n >= 4)
    {
	  try
      { 
	      String ofst = st.nextToken().trim();
	      if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Ofst: " + ofst);
	      offsetAmt = new Integer(ofst).intValue();
	    }
      catch(NumberFormatException nfe1) 
      {
	      cmdOut("500 ***Syntax error in parameters or arguments***");
	      continueOn = false;
      }
    }
    if (continueOn && retrFile.isFile())
    {
      cmdOut("150 ***File Status ok.  Opening data connection for transfer.***");
      if (dataLink.openDataConnection("FILE TRANSFER"))
         {
		       TRANSFER_IN_PROGRESS = true;
           // Start a thread to do the data transfer
           newTransfer = new RftpTransferServer(dataLink,this,retrFile,offsetAmt, "OUT");
	         Thread newTransferThread = new Thread(newTransfer);
	         newTransferThread.start();
	       }
    }
    else if (!retrFile.isFile())
    {
	cmdOut("550 ***Requested Action Not Taken.  File Not Found.***");
    }
  }
}
//*******************************************************************************************
//*******************************************************************************************
protected void STORcmd(String cmdLine)
{
  StringTokenizer st = new StringTokenizer(cmdLine);
  String sendMe = null;
  String receiveMe = null;
  FileOutputStream receiveFileOutStream = null;
  File receiveFile = null;
  boolean RESUME = false;
  int startPosition = 0;
  int n = st.countTokens();
  if (n < 2)  cmdOut("501 ***Syntax error in parameters or arguments***");
  else
  {
    String skipover = st.nextToken();   //first token is the STOR
    if (n == 2) receiveMe = st.nextToken();
    else
    {
         sendMe =  st.nextToken();   //don't really need name of file on client
	   String thirdToken = st.nextToken(); 
	   if (! thirdToken.equals("+")) receiveMe = thirdToken;
	     else  // thirdToken was +
	     {
		     RESUME = true;
		     receiveMe = sendMe;
	     }
     if (!FilePermissionOK(receiveMe))  {
       cmdOut("500 ***File Access denied***");
       return;
    }
	  if (n >= 4)
		 if (st.nextToken().equals("+")) RESUME = true;
    }
    try
    { //System.out.println("STOR: " + sendMe + " " + receiveMe + " RESUME: " + RESUME);
      if (!RESUME) receiveFileOutStream = new FileOutputStream(receiveMe);
      receiveFile = new File(receiveMe);

      if (!RESUME) startPosition = 0 ;
        else startPosition = (int) receiveFile.length();

      cmdOut("150 ***File Status ok.  Opening data connection for transfer.***");
      if (dataLink.openDataConnection("FILE TRANSFER"))
         {
		       TRANSFER_IN_PROGRESS = true;
 	         // Start a thread to do the data transfer
            newTransfer = new RftpTransferServer(dataLink,this,receiveFile,startPosition, "IN");
	          Thread newTransferThread = new Thread(newTransfer);
	          newTransferThread.start();
	       }
     } catch (IOException ecpt) 
	 {
	   cmdOut("550 ***Requested Action Not Taken.  Couldn't create file.***");
	 }
  }
}
//*******************************************************************************************
//*******************************************************************************************

protected void ABORcmd(String cmdLine)
{
	if (!TRANSFER_IN_PROGRESS) cmdOut("550 ***No transfer in progress***");
	else 
	{
	   newTransfer.stop();
	   cmdOut("226 ***File transfer aborted successfully.***");
	}
}
//*******************************************************************************************
//*******************************************************************************************
protected void DELEcmd(String cmdLine)
{
  StringTokenizer st = new StringTokenizer(cmdLine);
  int n = st.countTokens();
  if (n != 2)  cmdOut("501 ***Syntax error in parameters or arguments***");
  else
  {
    String skipover = st.nextToken();   //first token is the DELE
    String deleteMe = st.nextToken();
    if (!FilePermissionOK(deleteMe))  {
       cmdOut("500 ***File Access denied***");
       return;
    }
    File delName = new File(deleteMe);
    if (delName.isFile())
    {
	delName.delete();
	cmdOut("250 ***File Deleted***");
    }
    else
    {
	cmdOut("550 ***Requested Action Not Taken.  File Not Found.***");
    }
  }
}
//*******************************************************************************************
//*******************************************************************************************
protected void MKDcmd(String cmdLine){
 StringTokenizer st = new StringTokenizer(cmdLine);
  int n = st.countTokens();
  if (n != 2)  cmdOut("501 ***Syntax error in parameters or arguments***");
  else
  {
    String skipover = st.nextToken();   //first token is the MKD
    String makeMe = st.nextToken();
    if (!FilePermissionOK(makeMe))  {
       cmdOut("500 ***File Access denied***");
       return;
    }
    File mkdDirectory = new File(makeMe);
    if (!mkdDirectory.exists()) {
       mkdDirectory.mkdir();
       cmdOut("212 ***Directory created.***");
    }
    else // directory already exists
       cmdOut("550 ***Directory already exists.***");
  }
}
//*******************************************************************************************
//*******************************************************************************************
protected void PWDcmd(String cmdLine)
{
	  //  java does not allow changing of the working directory.
	  // the client process therefore keeps track of the current working directory
	  // PWD with no parameter sends info on the true working directory
 	  // pwd pathname sends info on the directory given as a parameter && is used
	  // by the client when the user changes the working directory to let the user see 
	  // if the pathname is an actual directory.

    StringTokenizer st = new StringTokenizer(cmdLine);
    int n = st.countTokens();
	  File dir;
	  String dirname;
	  boolean noSuchDir = false;
	  if (n == 1)  // asking about the true working directory
        {
       if (allowedDirectory.equals("*")) dir = new File(".");
	     else dir = new File(allowedDirectory);
	     dirname = dir.getAbsolutePath();
	  }
	  else    // use the passed name
        {
           String skipover = st.nextToken();
	         String pathname = st.nextToken();
           if (!FilePermissionOK(pathname))  {
             cmdOut("500 ***File Access denied***");
             return;
           }
	         dir = new File(pathname);
           dirname = dir.getAbsolutePath();
	         if (!dir.exists()) noSuchDir = true;
	      }

    if (DEBUG) System.out.println("DEBUG Client " + clientId + ": PWD command");
         cmdOut("150 ***Opening data connection.***");

    if (dataLink.openDataConnection("CHARACTER DATA"))
    {
		   dataLink.sendData(dirname);
		   if (noSuchDir) cmdOut("553 ***No such directory***");
	        else cmdOut("200 ***PWD completed successfully***");
		   dataLink.closeDataConnection();
		   return;
	  }
         /* Added to serve the timing considerations of gui interface,
		which was dying here because the datalink was attempting to
		open before the gui was getting around to accepting the datalink
		So - if it failed, wait & try one more time.  */
	   else 
	   {
        try	{java.lang.Thread.sleep(5000);}
		     catch (java.lang.InterruptedException eee) {}
		    if (dataLink.openDataConnection("CHARACTER DATA"))
        {
		       dataLink.sendData(dirname);
	         if (noSuchDir) cmdOut("553 ***No such directory***");
	           else cmdOut("200 ***PWD completed successfully***");
	         dataLink.closeDataConnection();
		       return;
	      }
		    else if (noSuchDir) cmdOut("553 ***No such directory***");
			    else cmdOut("500 ***Could not open data connection.***");
	   }
}
//*******************************************************************************************
//*******************************************************************************************
protected void LISTcmd(String cmdLine)
{
  String[] FileNames;
  File DirectoryName;
  StringBuffer buf = new StringBuffer();
  String dirname = null;
  StringTokenizer st = new StringTokenizer(cmdLine);
  int n = st.countTokens();
  if (DEBUG)  System.out.println("DEBUG Client " + clientId + ": " + cmdLine + "Tokens: " + Integer.toString(n));
  if  (n == 1)  // use the current directory
  {
      if (allowedDirectory.equals("*")  ) dirname = ".";
	     else dirname = allowedDirectory;
	}
  else if (n == 2)  // use the passed name
       {
         String skipover = st.nextToken();
         dirname = st.nextToken();
         if (!FilePermissionOK(dirname))
         {
           cmdOut("500 ***File Access denied***");
           return;
         }
	     }
       else // incorrect parameter count in LIST command
         {
           cmdOut("501 ***Syntax error in parameters or arguments.***");
	         return;
         }
  if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Dirname: " + dirname);
  DirectoryName = new File(dirname);
  if (!DirectoryName.exists())
     {  if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Directory doesn't exist");
         cmdOut("501 ***File or Directory Name not found.***");
	       return;
     }
    else if (DirectoryName.isFile())  //DirectoryName is NOT such a good name - this is a file
     {   if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Directory is a normal file");
	      cmdOut("150 ***File status okay; about to open data connection.***");
	      if (dataLink.openDataConnection("CHARACTER DATA"))
	      {
		      dataLink.sendData(dirname + " Last Modified: " + new Date(DirectoryName.lastModified()).toString() + " Size: " +  DirectoryName.length());
		      if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Sending ");
	        cmdOut("226 ***Closing data connection. Request Successful.***");
		      dataLink.closeDataConnection();
	      }
	      else cmdOut("425 *** .***");

     }
    else    //is a directory or a drive
     { if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Directory is directory or drive");
       FileNames = DirectoryName.list();
 	     cmdOut("150 ***File status okay; about to open data connection.***");
       if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Going to open data connection for dir or drive");
       if (dataLink.openDataConnection("CHARACTER DATA")) 
	     {  if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Opened connection.  Building string");
		      buf.setLength(0);        //  From JDK 1.1.6
	      	for (int fn = 0; fn < FileNames.length; fn++)
		      {
		        File thisfile = new File(DirectoryName,FileNames[fn]);
		        if (thisfile.isFile()) buf.append(FileNames[fn]).append('\n');
		        	else buf.append("<dir> ").append(FileNames[fn]).append('\n');
		      }
		   //if (DEBUG) System.out.println("DEBUG Client " + clientId + ": String= " + buf.toString());
		   dataLink.sendData(buf.toString());
 	     cmdOut("226 ***Closing data connection. Request Successful.***");
		   dataLink.closeDataConnection();
	   }
	   else cmdOut("425 ***Can't open data connection.***");
     }
 }
//*******************************************************************************************
//*******************************************************************************************
// Some ftp commands are optional for implementation.
// These commands were not implemented in RFTP
protected void NLSTcmd(String cmdLine){cmdOut("502 ***Command not implemented.***");}
protected void SITEcmd(String cmdLine){cmdOut("502 ***Command not implemented.***");}
protected void SYSTcmd(String cmdLine){cmdOut("502 ***Command not implemented.***");}
protected void ACCTcmd(String cmdLine){cmdOut("502 ***Command not implemented.***");}
protected void CWDcmd(String cmdLine) {cmdOut("502 ***Command not implemented.***"); }
protected void REINcmd(String cmdLine){cmdOut("502 ***Command not implemented.***");}
protected void RNFRcmd(String cmdLine){cmdOut("502 ***Command not implemented.***");}
protected void RNTOcmd(String cmdLine){cmdOut("502 ***Command not implemented.***");}
protected void RMDcmd(String cmdLine) {cmdOut("502 ***Command not implemented.***");}
//*******************************************************************************************
//*******************************************************************************************
protected void HELPcmd(String cmdLine){cmdOut("200 ***Resumable file transfer protocol.  Commands are STOR RETR ABOR DELE MKD PWD LIST STAT ***");}
//*******************************************************************************************
//*******************************************************************************************
protected void STATcmd(String cmdLine)
{
  StringTokenizer st = new StringTokenizer(cmdLine);
  int n = st.countTokens();
  if (n > 2) {
     cmdOut("500 ***Usage: STAT filename***");
     return;
     }
  if (n == 1)   
  {
	StringBuffer buf = new StringBuffer(300);
	buf.append("211 ***SYSTEM STATUS:").append("\n").append("  Data Connection:      " );
	buf.append(dataLink.connectionStatus()).append("\n").append("  Transfer in Progress: " ) ;
	buf.append(TRANSFER_IN_PROGRESS ).append("\n").append("  Debugging mode on:    " ).append(DEBUG).append("***");
      cmdOut(buf.toString());
  }
  else if (n == 2)  
  {
    String skipover = st.nextToken();   //first token is the STAT
    String statusMe = st.nextToken();
     if (!FilePermissionOK(statusMe))  {
       cmdOut("500 ***File Access denied***");
       return;
    }
    File statusFile = new File(statusMe);
    if (!statusFile.exists())
    {  if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Directory doesn't exist");
       cmdOut("501 ***File or Directory Name not found.***");
	     return;
    }
    else if (statusFile.isFile())
    {   
	     if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Directory is a normal file");
	     cmdOut("213 ***File status:: Last Modified: " + new Date(statusFile.lastModified()).toString() + " Size: " +  statusFile.length() + "***");
    }
    else    //is a directory or a drive
    {
	    if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Directory is directory or drive");
	    String[] FileNames = statusFile.list();
	    StringBuffer buf = new StringBuffer();
       
	    for (int fn = 0; fn < FileNames.length; fn++)
	    {
	     buf.append(FileNames[fn]).append("\n");
	    }
 	    cmdOut("212 ***Directory Listing: ***"+ buf.toString());
    }
  }
}
//*******************************************************************************************
//*******************************************************************************************

protected void DEBUGcmd(String cmdLine)
{
  StringTokenizer st = new StringTokenizer(cmdLine);
  int n = st.countTokens();
  String skipover = st.nextToken();
  String setDEBUG = st.nextToken();
  if (setDEBUG.equals("true")) DEBUG = true; else DEBUG = false;
  if (dataLink != null) dataLink.setDEBUG(DEBUG);
  cmdOut("200 ***Debug mode set as requested***");
}
//*******************************************************************************************
//*******************************************************************************************

protected void logout()
{
    try
	  {
	      dataLink.closeDataConnection();
	    	if (cmdSend != null) cmdSend.close();
        if (cmdReceive != null) cmdReceive.close();
        if (cmdSocket != null)  cmdSocket.close();
        } catch (IOException excpt) {if (DEBUG) System.out.println("Failed during closing " + excpt);}
}// end protected void logout()


//*******************************************************************************************
//*******************************************************************************************
public void setTransferComplete(String endStat)
{
  TRANSFER_IN_PROGRESS = false;
  if (endStat.equals("COMPLETE")) 
  {
    	cmdOut("226 ***File Transferred. Closed data Connection.***");
      if (DEBUG)System.out.println("DEBUG Client " + clientId + " File Transfer Complete");
  }
  else
  {
       cmdOut("426 ***Requested file transfer aborted***");
       if (DEBUG)System.out.println("DEBUG Client " + clientId + " File Transfer Aborted");
  }
}

//*******************************************************************************************
//*******************************************************************************************

}   // end class RftpHandler 

}

class RftpTransferServer implements Runnable
{
private RftpDataServer dataLink;
private RftpServer.RftpHandler parent;
private File dataFile;
private int startPosition;
private byte dataInput[] = new byte[64000];
private String direction;
private boolean TRANSFER_ABORTED = false;

/* This thread keeps track of its parent to inform it when the data
transfer is completed.  */

public RftpTransferServer(RftpDataServer dl, RftpServer.RftpHandler p, File f, int pos, String dir)
{
   dataLink = dl;
   parent = p;
   dataFile = f;
   startPosition = pos;
   direction = dir;
}
public void run()
{
   TRANSFER_ABORTED = false;
   if (direction.equals("OUT"))dataLink.transferFileOut(dataFile,startPosition);
	   else dataLink.transferFileIn(dataFile,startPosition);
   if (!TRANSFER_ABORTED)
   {
     dataLink.closeDataConnection();
     parent.setTransferComplete("COMPLETE");
   }
}
public void stop()
{  
   TRANSFER_ABORTED = true;
   dataLink.closeDataConnection();
   parent.setTransferComplete("ABORTED");
}

}  //end class RftpTransferServer

class RftpDataServer
{

private static final int MAX_CLIENTS = 50;
private static final boolean AUTOFLUSH = true;
private InetAddress server;
private String IPaddress;
private InetAddress clientIP;
private int client_data_port = 2405;
private Socket dataSocket = null;
private BufferedReader charReceive = null;
private PrintWriter charSend = null;
private BufferedInputStream byteReceive = null;
private BufferedOutputStream byteSend = null;
private boolean OPENDATA = false;
private boolean DEBUG = false;
private int clientId = 0;
//*******************************************************************************************
//*******************************************************************************************
public RftpDataServer(InetAddress client,int clientNumber)
{
clientIP = client;
clientId = clientNumber;
}
//*******************************************************************************************
//*******************************************************************************************

public boolean openDataConnection(String streamType)
{   if (DEBUG)  System.out.println("DEBUG Client " + clientIP + ": Opening Data Connection ");
    //connect the data link
    if (!OPENDATA) try
    {
       dataSocket = new Socket (clientIP, client_data_port);
	     if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Socket: " + dataSocket.toString());

      if (streamType.equals("CHARACTER DATA"))
     	{
       charReceive = new BufferedReader(new InputStreamReader(dataSocket.getInputStream()));
	     if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Data Buffered Reader: " + charReceive.toString());

       charSend = new PrintWriter(dataSocket.getOutputStream(),AUTOFLUSH);
	     if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Data PrintWriter: " + charSend.toString());
	    }
	  else if (streamType.equals("FILE TRANSFER"))
	  {
	    byteReceive = new BufferedInputStream(dataSocket.getInputStream());
	    byteSend = new BufferedOutputStream(dataSocket.getOutputStream(),64000);
	  }
    OPENDATA = true;
  	return true;
    }
    catch (UnknownHostException excpt) 
    {
	     System.out.println("DEBUG Client " + clientId + ": UnknownHost Exception: " + excpt);
	     closeDataConnection();
       return false;
    }
    catch (IOException excpt)
    {  
	      System.out.println("DEBUG Client " + clientId + ": UnknownHost Exception: " + excpt);
        closeDataConnection();
	      return false;
    }
    else 
    {
	/* if (DEBUG)*/ System.out.println("DEBUG Client " + clientId + ": Returning true with an open data connection.");
	return true;
    }
}  // end openDataConnection()

//*******************************************************************************************
//*******************************************************************************************

public void closeDataConnection()
{
        
    try
    {
	if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Closing data connection." );
      Thread.sleep(1505);
    }
    catch (InterruptedException  eee) {}

    if (OPENDATA) try
    {
	if (charSend != null) charSend.close();
      if (charReceive != null) charReceive.close();
	if (byteSend != null) byteSend.close();
      if (byteReceive != null) byteReceive.close();
      if (dataSocket != null)  dataSocket.close();
    }
    catch (IOException excpt) 
	  {if (DEBUG)
            System.out.println("426 Connection closed; Exception during closing." + excpt);
	   OPENDATA = false;
        }

    OPENDATA = false;
}

//*******************************************************************************************
//*******************************************************************************************
public String getDataString()
{
   String dataInput = null;
   try
    {
       dataInput = charReceive.readLine();
    }
   catch (IOException excpt) 
    {
	if (DEBUG) System.out.println("I/O Exception While contacting server: " + excpt);
	System.exit(1);
    }
   if (DEBUG) System.out.println(dataInput);
   return dataInput;
}



//*******************************************************************************************
//*******************************************************************************************
public void sendData(String h)
{
   if (DEBUG) System.out.println("DEBUG Client " + clientId + ": Sending the data over data connection.");
  if (DEBUG) System.out.println(h);
   charSend.print(h);
   charSend.flush();
}
//*******************************************************************************************
//*******************************************************************************************

public void transferFileOut(File outFile,int startPosition)
{
  byte[] buf = new byte[64000];
  int amtRead = 0;
  long fileSize;
  int transferAmt;
  int sizeOfRead;
  try
  {
	RandomAccessFile fo = new RandomAccessFile(outFile,"rw");  
	int pointAt = (int) fo.getFilePointer();
	if (DEBUG) System.out.println("DEBUG Client " + clientId + " filepointer: " + Integer.toString(pointAt));
	if (startPosition > 0) fo.seek((long) startPosition);
	pointAt = (int) fo.getFilePointer();
	if (DEBUG) System.out.println("DEBUG Client " + clientId + " filepointer: " + Integer.toString(pointAt));

	fileSize = outFile.length();
      transferAmt = (int) fileSize - startPosition;
	BufferedInputStream fileIn = new BufferedInputStream (new FileInputStream(fo.getFD()), 64000);
 	while ((amtRead < transferAmt) && OPENDATA)
	{
  	if ( (transferAmt - amtRead) >= 64000) sizeOfRead = 64000;
		   else sizeOfRead = (int) (transferAmt - amtRead);
	  fileIn.read(buf,0,sizeOfRead);
	  byteSend.write(buf,0,sizeOfRead);
	  amtRead = sizeOfRead + amtRead;
	}
      if (DEBUG) System.out.println("DEBUG Client " + clientId + ": File transfer: Amt Read : " +
		Integer.toString(amtRead)  );
	fileIn.close();
  }
  catch (IOException eeeee)
  {  // also occurs upon read/write fail
  }
}

//*******************************************************************************************
//*******************************************************************************************

public void transferFileIn(File outFile, int startPosition)
{
  byte[] buf = new byte[64000];
  int amtRead;
  BufferedOutputStream fileOut = null;
  try
  {
      RandomAccessFile fo = new RandomAccessFile(outFile,"rw");
	    int pointAt = (int) fo.getFilePointer();
     	if (DEBUG) System.out.println("DEBUG Client " + clientId + " filepointer: " + Integer.toString(pointAt));
	    if (startPosition > 0) fo.seek((long) startPosition);
	    pointAt = (int) fo.getFilePointer();
	    if (DEBUG) System.out.println("DEBUG Client " + clientId + " filepointer: " + Integer.toString(pointAt));

	    if (DEBUG) System.out.println("DEBUG: In transferFileIn ");
	    fileOut = new BufferedOutputStream (new FileOutputStream(fo.getFD()), 64000);
      if (DEBUG) System.out.println("DEBUG: Created BufferedOutputStream");
	    amtRead = 1;
 	    while (amtRead > 0)
	    {
	      amtRead = byteReceive.read(buf,0,64000);
        if (amtRead > 0) fileOut.write(buf,0,amtRead);
	    }
	    if (DEBUG) System.out.println("DEBUG Client " + clientId + " read from input stream, wrote to file. amtRead:" + Integer.toString(amtRead));
  } 
  catch (IOException eeeee)
  {  // normal end to file transfer - data stream closed - also occurs upon read/write fail
  }
  try {fileOut.close();} catch (IOException eeeee) { }
}

//*******************************************************************************************
//*******************************************************************************************
public void setDEBUG(boolean h)
{
   DEBUG = h;
}
//*******************************************************************************************
//*******************************************************************************************
public String connectionStatus()
{
  if (OPENDATA) return ("Open"); else return ("Closed");
}

}  //end class RftpDataServer
